#!/usr/bin/perl
# indexsoft access manager
# http://www.indexsoft.com

$|++;
&ReadParameters();
$VER = '1.04 shareware';
$configerror = &CheckConfig();

# if save config - save and reload
if (($P{'todo'} eq 'saveconfig') and $P{'cfgfilecontent'})
{
	$P{'cfgfilecontent'} =~ s/\r//g;
	open(FILE, ">accessmanager.pm") || &HoldError('Can not rewrite config file <i>accessmanager.pm</i>');
	binmode('FILE');
	print FILE $P{'cfgfilecontent'};
	close FILE;
	print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nLocation: accessmanager.cgi?todo=configure\n\n};
}

print &TopOfPage();

# if not configire
if (($P{'todo'} ne 'saveconfig') and ($P{'todo'} ne 'configure') and !$configerror)
{
	# create default .htpasswd
	if (!-e $PassFile or -z $PassFile )
	{
		print qq{<p><b>First run or .htpasswd is empty:</b> .htpasswd file with user <i>'administrator'</i> and default password has been created. Please change password for <i>'administrator'</i> from <a href="accessmanager.cgi?todo=managehtpasswd">manage users</a>.</p>};
		&HoldError("Error creating default .htpasswd file") if (system qq{$ChangeUserCommand -b -c $Encryption "$PassFile" "administrator" "$AdminPassword"});
	}
	# create default .htgroups
	if (!-e $GroupFile)
	{
		print qq{<p><b>First run:</b> .htgroups file with group <i>'administrators'</i> and member <i>'administrator'</i> has been created.</p>};
		open (FILE, ">$GroupFile") || &HoldError("Error creating default .htgroup file");
		binmode('FILE');
		print FILE "administrators:administrator\n";
		close(FILE);
	}
}

# select todo
if (($P{'todo'} eq 'configure') or $configerror)
{
	print &EditConfigForm();
}
elsif (($P{'todo'} eq 'dirwalk'))
{
	print &DirWalker($WebRootDir, $P{'dir'});
}
elsif ($P{'todo'} eq 'unprotectdir' and $P{'dir'} and (-e "$P{'dir'}$DirSeparator.htaccess"))
{
	print qq{<p><b>This feature disabled on shareware version. <a href="http://www.indexsoft.com/passmanagerpro/">Please register</a>.</b></p><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Please register shareware');\n//-->\n</SCRIPT>};
	print &StartForm();
}
elsif ($P{'todo'} eq 'edithtaccess' and $P{'dir'})
{
	$htaccesscontent = $htaccessTempl;
	if (-e "$P{'dir'}$DirSeparator.htaccess")
	{
		$htaccesscontent = '';
		open (FILE, "$P{'dir'}$DirSeparator.htaccess") || &HoldError("Cannot open file <i>'$P{'dir'}$DirSeparator.htaccess'</i>");
		foreach (<FILE>) { ($htaccesscontent .= $_) if ($_ ne "\n"); }
		close (FILE);
	}
	print &ManageUsersForm($P{'dir'}, $htaccesscontent);
}
elsif ($P{'todo'} eq 'protectdir' and $P{'dir'} and $P{'htaccessfile'})
{
	$P{'htaccessfile'} =~ s/\r//g;
	$P{'htaccessfile'} .= "\n";
	print "<p><b>Operation:</b> protect directory <i>'$P{'dir'}'</i> with .htaccess; Name of protected area is <i>'$P{'areaname'}'</i></p>";
	foreach (split (/\0/, $P{'users'}))	{ $P{'htaccessfile'} .= "require user $_\n" };
	foreach (split (/\0/, $P{'groups'}))	{ $P{'htaccessfile'} .= "require group $_\n" };
	$P{'htaccessfile'} .= qq{AuthName "$P{'areaname'}"\n};
	if ($P{'users'})
	{
		open (FILE, ">$P{'dir'}$DirSeparator.htaccess") || &HoldError("Cannot create file <i>'$P{'dir'}$DirSeparator.htaccess'</i>");
		binmode('FILE');
		print FILE $P{'htaccessfile'};
		close (FILE);
		print &StartForm($P{'dir'});
	}
	else
	{
		&HoldError('No users selected. This will remove protection from directory. If you want to remove protection click botton <b>"Remove protection"</b>. Changes not saved.');
		$htaccesscontent = $htaccessTempl;
		if (-e "$P{'dir'}$DirSeparator.htaccess")
		{
			$htaccesscontent = '';
			open (FILE, "$P{'dir'}$DirSeparator.htaccess") || &HoldError("Cannot open file <i>'$P{'dir'}$DirSeparator.htaccess'</i>");
			foreach (<FILE>) { $htaccesscontent .= $_; }
			close (FILE);
		}
		print &ManageUsersForm($P{'dir'}, $htaccesscontent);
	}
}
# all about manage .htpasswd
elsif (($P{'todo'} eq 'adduser') and $P{'username'} and $P{'userpass'})
{
	$P{'username'} =~ s/^#//;
	print "<p><b>Operation:</b> add new user <i>'$P{'username'}'</i></p>";
	open (FILE, $PassFile);
	@USERS = <FILE>;
	close(FILE);
	if (!grep (($_ =~ /^$P{'username'}:.*$/ or $_ =~ /^#$P{'username'}:.*$/), @USERS))
	{
		$command = qq{$ChangeUserCommand -b }.((!-e $PassFile)?'-c':'').qq{ $Encryption "$PassFile" "$P{'username'}" "$P{'userpass'}"};
		$code = system "$command";
		&HoldError("Command <i>$command</i> executed with error") if ($code);
	}
	else { $P{'username'} =~ s/^#//; &HoldError("User '$P{'username'}' already exist"); }
	print &ManageHtpasswdForm();
}
elsif (($P{'todo'} eq 'changeuserpass') and $P{'username'} and $P{'userpass'})
{
	print qq{<p><b>This feature disabled on shareware version. <a href="http://www.indexsoft.com/passmanagerpro/">Please register</a>.</b></p><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Please register shareware');\n//-->\n</SCRIPT>};
	print &ManageHtpasswdForm();
}
elsif (($P{'todo'} eq 'deleteusers') and $P{'usersnames'})
{
	@USERS = split(/\0/,$P{'usersnames'});
	print "<p><b>Operation:</b> delete users</p>";
	open (FILE, $PassFile);
	# from htpasswd
	foreach $line(<FILE>)
	{
		($user,$pass) = split(/\:/,$line);
		push (@LINES, $line) if (!grep ($_ eq $user, @USERS));
	}
	close(FILE);
	open (FILE, ">$PassFile") || &HoldError("Can not write to <i>$PassFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print FILE $_; }
	close(FILE);
	# from htgroups
	$#LINES = -1;
	open (FILE, $GroupFile);
	foreach $line(<FILE>)
	{
		($group, $user) = split(/\:/,$line);
		push (@LINES, $line) if (!grep ("$_\n" eq $user, @USERS));
	}
	close(FILE);
	open (FILE, ">$GroupFile") || &HoldError("Can not write to <i>$GroupFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print  FILE $_; }
	close(FILE);
	print &ManageHtpasswdForm();
}
elsif (($P{'todo'} eq 'disableusers'))
{
	@USERS = split(/\0/,$P{'usersnames2'});
	print "<p><b>Operation:</b> disable/enable users</p>";
	open (FILE, $PassFile);
	foreach $line(<FILE>)
	{
		($user,$pass) = split(/\:/,$line);
		if (grep($_ eq $user, @USERS)) { ($user !~ /^#/)?push(@LINES, "#$line"):push(@LINES, "$line") }
		else { $line =~ s/^#//; push(@LINES, $line) }
	}
	close(FILE);
	open (FILE, ">$PassFile") || &HoldError("Can not write to <i>$PassFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print FILE $_; }
	close(FILE);
	print &ManageHtpasswdForm();
}
elsif ($P{'todo'} eq 'managehtpasswd' or $P{'from'} eq 'managehtpasswd')
{
	print &ManageHtpasswdForm();
}
# all about manage .htgroups
elsif ($P{'todo'} eq 'changemembers' and $P{'groupname'})
{
	print qq{<p><b>This feature disabled on shareware version. <a href="http://www.indexsoft.com/passmanagerpro/">Please register</a>.</b></p><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Please register shareware');\n//-->\n</SCRIPT>};
	print &ViewGroupsInfo();
}
elsif ($P{'todo'} eq 'viewmembers' and $P{'groupname'})
{
	print qq{
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Select members of group <i>$P{'groupname'}</i>
	</td></tr></table></td></tr></table>
	<form action="accessmanager.cgi" method="post">
	<input type="hidden" name="todo" value="changemembers">
	<input type="hidden" name="groupname" value="$P{'groupname'}"><ul>};
	open (FILE, $GroupFile);
	grep (do{chomp $_; ($group, $user) = split(/\:/,$_); $group =~ s/^#//; push (@GROUPUSERS, $user) if ($group eq $P{'groupname'} and $user);}, <FILE>);
	close(FILE);
	open (FILE, $PassFile);
	foreach $line(<FILE>)
	{
		($user,$pass) = split(/\:/,$line);
		($user =~ s/^#//)?($disabled = ' <i>(user disabled)</i>'):($disabled = '');
		print qq{<li><input type="checkbox" name="members" value="$user"}.((grep($_ eq $user, @GROUPUSERS))?' checked':'').qq{> $user$disabled<br>};
	}
	close(FILE);
	print '</ul><input type="submit" value="Change members"> <input type="Reset"></form>';
}
elsif ($P{'todo'} eq 'disablegroups')
{
	@GROUPS = split(/\0/,$P{'groupnames2'});
	print "<p><b>Operation:</b> disable/enable groups</p>";
	open (FILE, $GroupFile);
	foreach $line(<FILE>)
	{
		($group,$user) = split(/\:/,$line);
		if (grep($_ eq $group, @GROUPS)) { ($group !~ /^#/)?push(@LINES, "#$line"):push(@LINES, "$line") }
		else { $line =~ s/^#//; push(@LINES, $line) }
	}
	close(FILE);
	open (FILE, ">$GroupFile") || &HoldError("Can not write to <i>$GroupFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print FILE $_; }
	close(FILE);
	print &ViewGroupsInfo();
}
elsif ($P{'todo'} eq 'deletegroups' and $P{'groupnames'})
{
	@GROUPS = split(/\0/,$P{'groupnames'});
	print "<p><b>Operation:</b> delete groups</p>";
	open (FILE, $GroupFile);
	foreach $line(<FILE>)
	{
		($group,$user) = split(/\:/,$line);
		$group =~ s/^#//;
		push (@LINES, $line) if (!grep ($_ eq $group, @GROUPS));
	}
	close(FILE);
	open (FILE, ">$GroupFile") || &HoldError("Can not write to <i>$GroupFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print FILE $_; }
	close(FILE);
	print &ViewGroupsInfo();
}
elsif ($P{'todo'} eq 'addgroup' and $P{'groupname'})
{
	$P{'groupname'} =~ s/^#//;
	print "<p><b>Operation:</b> add new group <i>'$P{'groupname'}'</i></p>";
	open (FILE, $GroupFile);
	@GROUPS = <FILE>;
	close(FILE);
	if (!grep (($_ =~ /^$P{'groupname'}:.*$/ or $_ =~ /^#$P{'groupname'}:.*$/), @GROUPS))
	{
		open (FILE, ">>$GroupFile") || &HoldError("Can not write to <i>$GroupFile</i>");
		binmode('FILE');
		print FILE "$P{'groupname'}:\n";
		close(FILE);
	}
	else { &HoldError("Group '$P{'groupname'}' already exist"); }
	print &ViewGroupsInfo();
}
elsif ($P{'todo'} eq 'managehtgroups' or $P{'from'} eq 'managehtgroups')
{
	print &ViewGroupsInfo();
}
elsif (($P{'todo'} eq 'checkver'))
{
	print qq{<p><iframe src="http://www.indexsoft.com/checkver.px?program=accessmanager&ver=$VER" width="550" height="100" marginwidth="0" marginheight="0" scrolling="no" frameborder="0"><p>Please visit <a href="http://www.indexsoft.com/passmanagerpro/" target="_top">home page of <i>indexsoft access manager</i></a> to check new version.</p><br><br><br><br><br><br><br></iframe></p>};
}
else
{
	print &StartForm();
}
print &BottomOfPage();

#################################################################################
sub DirWalker
{
	my ($rootdir, $dir) = @_;
	my $result, $file, $areaname;
	local *DIR;
	if (!$dir or !-d "$dir") { $dir = $rootdir }
	$result = qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Protect / Change permission
	</td></tr></table></td></tr></table>
	<p>Selected: <i>$dir</i><br>};
	if (-e "$dir$DirSeparator.htaccess")
	{
		$areaname = '';
		open (FILE, "$dir$DirSeparator.htaccess") || &HoldError("Cannot open file <i>'$dir$DirSeparator.htaccess'</i>");
		foreach (<FILE>) { ($areaname .= $_) if ($_ ne "\n"); }
		close (FILE);
		$areaname =~ /\nAuthName "(.*)"/;
		$result .= qq{Status: <i>Protected</i><br>Area name: <i>$1</i></p><p>&#149; <a href="accessmanager.cgi?todo=edithtaccess&dir=$dir">change name of protected area or users permission to this directory</a><br>&#149; <a href="accessmanager.cgi?todo=unprotectdir&dir=$dir" onclick="return confirm('Are you sure you want to delete .htaccess file for current directory?\\n\\'$1\\' will be deleted!')">remove .htaccess protection from this directory</a></p>}
	}
	else
	{
	 $result .= qq{Status: <i>Unprotected</i></p><form action="accessmanager.cgi"><input type="hidden" name="todo" value="edithtaccess"><input type="hidden" name="dir" value="$dir"><input type="submit" value="Protect it!"></form>}
	}
	$result .= qq{
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Select another directory for protect
	</td></tr></table></td></tr></table>
	};
	opendir (DIR, $dir);
	$result .= '<ul>';
	$dir =~ /^(.*)(\\|\/)/;
	$result .= qq{<li><a title="go to parent directory" href="accessmanager.cgi?todo=dirwalk&dir=$1"><b>..</b></a>} if ($rootdir ne $dir);
	while ($file = readdir(DIR))
	{
		(-d "$dir$DirSeparator$file")
		?	(do {$result .= qq{<li><a title="change current directory to '$file'" href="accessmanager.cgi?todo=dirwalk&dir=$dir$DirSeparator$file">$file</a>} if ($file ne '.' and $file ne '..')})
		:	($result .= qq{<li>$file});
	}
	$result .= '</ul>';
	closedir(DIR);
	return $result;
}

sub ManageUsersForm
{
	my ($dir, $htaccescontent) = @_;
	my ($privusers, $line, $user, $pass, @htaccessusers, @htpasswdusers, $result, $htTempls, $i);
	local *FILE;
	$htaccescontent =~ s/\r//g;
	# array for users from .htpasswd
	open (FILE, $PassFile);
	grep ( do{ ($user,$pass) = split(/\:/,$_); push (@htpasswdusers, $user); }, <FILE>);
	close(FILE);
	# array for groups
	open (FILE, $GroupFile);
	grep ( do{ ($group,$user) = split(/\:/,$_); push (@htgroups, $group) if (!grep($_ eq $group, @htgroups)); }, <FILE>);
	close(FILE);
	#users
	foreach $line(split (/\n/, $htaccescontent))
	{
		if ($line =~ /^require user (.*)/)
		{
			$user = $1;
			push (@htaccessusers, $user);
			$privusers .= qq{<li><input type="checkbox" name="users" value="$user" checked>$user}.((!grep (($_ eq $user or $_ eq "#$user"), @htpasswdusers))?' <i>(user does not exist)</i>':'').((grep ($_ eq "#$user", @htpasswdusers))?' <i>(user disabled)</i>':'');
			$htaccescontent =~ s/$line\n//;
		}
		elsif ($line =~ /^AuthName (.*)/)
		{
			$areaname = $1;
			$areaname =~ s/\"//g;
			$htaccescontent =~ s/$line\n//;
		}
	}
	foreach $user(@htpasswdusers)
	{
		($user =~ s/^#//)?($disabled = ' <i>(user disabled)</i>'):($disabled = '');
		if (!grep ($_ eq $user, @htaccessusers)) { $privusers .= qq{<li><input type="checkbox" name="users" value="$user">$user$disabled} }
	}
	#groups
	foreach $line(split (/\n/, $htaccescontent))
	{
		if ($line =~ /^require group (.*)/)
		{
			$group = $1;
			push (@htaccessgroups, $group);
			$privgroups .= qq{<li><input type="checkbox" name="groups" value="$group" checked>$group}.((!grep (($_ eq $group or $_ eq "#$group"), @htgroups))?' <i>(group does not exist)</i>':'').((grep ($_ eq "#$group", @htgroups))?' <i>(group disabled)</i>':'');
			$htaccescontent =~ s/$line\n//;
		}
	}
	foreach $group(@htgroups)
	{
		($group =~ s/^#//)?($disabled = ' <i>(group disabled)</i>'):($disabled = '');
		if (!grep ($_ eq $group, @htaccessgroups)) { $privgroups .= qq{<li><input type="checkbox" name="groups" value="$group">$group$disabled} }
	}
  for ($i = 0; $i <= $#htTemplName; ++$i) 
	{
		$htTempls .= qq{<li><a href="#" onclick="InsertTemplate($i); return false;">$htTemplName[$i]</a>
		<textarea name="templ$i" style="display:none;">$htTempl[$i]</textarea>
		};
	}
	$result = q{
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
  <!--
  function InsertTemplate(num)
	{
		var template;
		template = eval ('document.protectarea.templ' + num + '.value');
		document.protectarea.htaccessfile.value = document.protectarea.htaccessfile.value + template;
		//eval ('document.protectarea.templname' + num + '.disabled = "true"');//
	}
  //-->
  </SCRIPT>}.
	qq{
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Protect: $dir
	</td></tr></table></td></tr></table>
	<form action="accessmanager.cgi" name="protectarea">
	<input type="hidden" name="todo" value="protectdir">
	<input type="hidden" name="dir" value="$dir">
	<b>1.</b> <i>name of protected area:</i><br>
	<ul><input type="text" name="areaname" value="$areaname"></ul>
	<b>2.</b> <i>select groups which should have access to the current directory:</i><br>
	<ul>$privgroups</ul>
	<b>3.</b> <i>select users which should have access to the current directory:</i><br>
	<ul>$privusers</ul>
	<b>4.</b> <i>click on template to insert it to .htaccess file:</i><br><br>
	<ul>$htTempls</ul>
	<b>5.</b> <i>edit .htaccess file if require:</i><br>
	<textarea cols="66" rows="15" name="htaccessfile" wrap="off" style="width=550px;">$htaccescontent</textarea><br><br>
	<table width="550" border="0" cellspacing="0" cellpadding="0"><tr><td><input type="submit" value="Protect it!"></td><td align="center"><input type="reset" value="Reset all changes"></td><td align="right"><input type="Submit" value="Remove protection"}.((!-e "$dir$DirSeparator.htaccess")?' disabled onclick="return false;"':qq{ onclick="if (confirm('Are you sure you want to delete .htaccess file for current directory?\\n\\'$areaname\\' will be deleted!')) { todo.value = 'unprotectdir' } else { return false; }"}).qq{></td></tr></table>
	</form>
	};
	return $result;
}

sub FindHtaccesFile
{
	my ($dir) = @_;
	local *DIR;
	opendir (DIR, $dir);
	while ($file = readdir(DIR))
	{
		if ($file eq '.htaccess') { push (@htaccessDirs, qq{$dir}) }
		elsif (-d "$dir$DirSeparator$file" and $file ne '.' and $file ne '..') { &FindHtaccesFile("$dir$DirSeparator$file") }
	}
	closedir(DIR);
}

sub StartForm
{
	my ($dir, $result, $protecteddirs, $areaname) = ('', '', '', '');
	local *FILE;
	@htaccessDirs = ();
	&FindHtaccesFile($WebRootDir);
	foreach $dir(@htaccessDirs)
	{
		$areaname = '';
		open (FILE, "$dir$DirSeparator.htaccess") || &HoldError("Cannot open file <i>'$dir$DirSeparator.htaccess'</i>");
		foreach (<FILE>) { ($areaname .= $_) if ($_ ne "\n"); }
		close (FILE);
		$areaname =~ /\nAuthName "(.*)"/;
		$protecteddirs .= qq{<li><a href="accessmanager.cgi?todo=edithtaccess&dir=$dir" title="}.($ShowAuthName?"$dir\">$1</a>":"$1\">$dir</a>");
	}
	$result = qq{
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Protected directories:
	</td></tr></table></td></tr></table>
	<ul>
		$protecteddirs
		<li><a href="accessmanager.cgi?todo=dirwalk">protect new directory</a></li>
	</ul>
	};
	return $result;
}

sub ManageHtpasswdForm
{
	my ($result) = ('');
	my $user, $realusername, $pass, $line;
	local *FILE;
	$result = qq{
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
	function Boxes(z)
	{
		if (z == 'delete')
		{
			document.selectuser.todo.value = 'deleteusers';
			document.selectuser.submit.value = 'Delete users';
			document.selectuser.submit.disabled = false;
			for (var i=0;i<document.selectuser.elements.length;i++) { var z=document.selectuser.elements[i]; if (z.name == 'username' || z.name == 'usersnames2') { z.checked = false } }
		}
		if (z == 'change')
		{
			document.selectuser.todo.value = 'changeuserpass';
			document.selectuser.submit.value = 'Change password';
			document.selectuser.submit.disabled = false;
			for (var i=0;i<document.selectuser.elements.length;i++) { var z=document.selectuser.elements[i]; if (z.name == 'usersnames' || z.name == 'usersnames2') { z.checked = false } }
		}
		if (z == 'disable')
		{
			document.selectuser.todo.value = 'disableusers';
			document.selectuser.submit.value = 'Disable/enable users';
			document.selectuser.submit.disabled = false;
			for (var i=0;i<document.selectuser.elements.length;i++) { var z=document.selectuser.elements[i]; if (z.name == 'username' || z.name == 'usersnames') { z.checked = false } }
		}
	}
	//-->
	</SCRIPT>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Select users for delete, disable/enable or change password
	</td></tr></table></td></tr></table>
	<form name="selectuser" action="accessmanager.cgi" method="post">
	<input type="hidden" name="from" value="managehtpasswd">
	<input type="hidden" name="todo" value="">
	<ul>};
	open (FILE, $PassFile);
	foreach $line(<FILE>)
	{
		($user,$pass) = split(/\:/,$line);
		$realusername = $user;
		($realusername =~ s/^#//)?($disabled = ' <i>(user disabled)</i>'):($disabled = '');
		$result .= qq{<li><input type="checkbox" name="usersnames" value="$user" title="select for delete" onclick="Boxes('delete')"> | <input type="checkbox" name="usersnames2" value="$user" title="disable/enable" onclick="Boxes('disable')"}.(($disabled)?' checked':'').qq{> | <input type="radio" name="username" value="$user" onclick="Boxes('change')"}.(($disabled)?' disabled title="can not change password for disabled user"':' title="select for change password"').qq{> | $realusername$disabled };
	}
	close(FILE);
	$result .= qq{
	</ul>
	<i>change password for selected user:</i><br><input type="password" name="userpass"><br><br><input name="submit" type="submit" value="  first select action  " disabled> <input type="Reset"></form>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Add user
	</td></tr></table></td></tr></table>
	<p><form name="adduser" action="accessmanager.cgi" method="post">
	<input type="hidden" name="from" value="managehtpasswd">
	<input type="hidden" name="todo" value="adduser">
	<i>user name:</i><br><input type="text" name="username"><br><i>password:</i><br><input type="password" name="userpass"><br><br>	<input type="submit" value="Add user">
	</form></p>
	};
	return $result;
}

sub ViewGroupsInfo
{
	my ($result, $line, $group, $user, @groups);
	local *FILE;
	$result = qq{
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
	function Boxes(z)
	{
		if (z == 'deletegroups')
		{
			document.selectgroup.todo.value = 'deletegroups';
			document.selectgroup.submit.value = 'Delete groups';
			document.selectgroup.submit.disabled = false;
			for (var i=0;i<document.selectgroup.elements.length;i++) { var z=document.selectgroup.elements[i]; if (z.name == 'groupnames2') { z.checked = false } }
		}
		if (z == 'disablegroups')
		{
			document.selectgroup.todo.value = 'disablegroups';
			document.selectgroup.submit.value = 'Disable/enable groups';
			document.selectgroup.submit.disabled = false;
			for (var i=0;i<document.selectgroup.elements.length;i++) { var z=document.selectgroup.elements[i]; if (z.name == 'groupnames') { z.checked = false } }
		}
	}
	//-->
	</SCRIPT>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Select groups for delete, disable/enable or edit members list
	</td></tr></table></td></tr></table>
	<form name="selectgroup" action="accessmanager.cgi" method="post">
	<input type="hidden" name="from" value="managehtgroups">
	<input type="hidden" name="todo" value=""><ul>};
	open (FILE, $GroupFile);
	foreach $line(<FILE>)
	{
		($group,$user) = split(/\:/,$line);
		$realgroupname = $group;
		($realgroupname =~ s/^#//)?($disabled = ' <i>(group disabled)</i>'):($disabled = '');
		if (!grep($_ eq $group, @groups)) { push(@groups, "$group"); $result .= qq{<li><input type="checkbox" name="groupnames" value="$realgroupname" title="select for delete" onclick="Boxes('deletegroups')"> | <input type="Checkbox" name="groupnames2" value="$group" title="disable/enabe" onclick="Boxes('disablegroups')"}.($disabled?' checked':'').qq{> <a href="accessmanager.cgi?todo=viewmembers&groupname=$realgroupname" title="members of group $realgroupname">$realgroupname</a>$disabled}; }
	}
	close(FILE);
	$result .= q{</ul><input name="submit" type="submit" value="  first select action  " disabled> <input type="Reset"></form>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Add new group
	</td></tr></table></td></tr></table>
	<form name="adduser" action="accessmanager.cgi" method="post"><input type="hidden" name="from" value="managehtgroups"><input type="hidden" name="todo" value="addgroup">
	<i>group name:</i><br><input type="text" name="groupname"> <input type="submit" value="Add group"></form>};
	return $result;
}

sub EditConfigForm
{
	local *IN;
	my $cfgfile, $document_root, $installdir, $nofile;
	open(IN, 'accessmanager.pm') || ($nofile = 1);
	grep ($cfgfile .= $_, <IN>);
	close IN;
	if ($nofile)
	{
		# template for config file
		$cfgfile = q{# if script running on Windows OS
if ($ENV{'WINDIR'})
{
	# empty for MD5 encryption of the password or '-m', '-d', '-s' 
 	$Encryption = '';
	
	# complete path and file name of the .htpasswd file
	$PassFile = '\webshare\wwwroot\closed\.htpasswd';
	
	# complete path and file name of the .htgroups file - groups of users
	$GroupFile = '\webshare\wwwroot\closed\.htgroups';
	
	# start path to a directory of a website to which contents you want to sets access restrictions), leave out trailing "\\" or "/"
	$WebRootDir = '\webshare\wwwroot\closed';
	
	# full path and a name of the program which is delivered with distribution of Apache and which is intended for addition of new users and change of their passwords
	$ChangeUserCommand = '\apache\bin\htpasswd.exe';
	
	# $DirSeparator must be '\\\\' for windows of '/' for *nux 
	$DirSeparator = '\\\\';
}
# if linux
else
{
	# empty for MD5 encryption of the password or '-m', '-d', '-s' 
 	$Encryption = '';
	
	# complete path and file name of the .htpasswd file
	$PassFile = '/pub/home/mysite/closed/.htpasswd';
	
	# complete path and file name of the .htgroups file - groups of users
	$GroupFile = '/pub/home/mysite/closed/.htgroups';
	
	# start path to a directory of a website to which contents you want to sets access restrictions), leave out trailing "\\" or "/"
	$WebRootDir = '/pub/home/mysite/closed';
	
	# full path and a name of the program which is delivered with distribution of Apache and which is intended for addition of new users and change of their passwords
	$ChangeUserCommand = '/usr/local/apache/bin/htpasswd';
	
	# $DirSeparator must be '\\\\' for windows of '/' for *nux 
	$DirSeparator = '/';
}
# if $ShowAuthName is equal to "1" instead of list of protected directories you will see the list of protected areas names. If it is "0" that list will contains protected directories
$ShowAuthName = '1';

# templete of .htaccess file for new protected directories
$htaccessTempl = qq{AuthType Basic\nAuthAuthoritative on\nAuthName "Restricted"\nAuthUserFile $PassFile\nAuthGroupFile $GroupFile\n<FilesMatch "\\\\.(htaccess|htgroups|htpasswd)\$">\n    Deny from all\n</FilesMatch>\nrequire user administrator\nrequire group administrators\n};

# default password for user administrator
$AdminPassword = 'administrator';

# lists of names for fragments and frequently used fragments of .htaccess files
$htTemplName[0] = 'Directory index files';
$htTempl[0] = "DirectoryIndex index.html index.pl index.cgi\n";
$htTemplName[1] = 'Allow scripts';
$htTempl[1] = "AddHandler cgi-script .pl .cgi\nOptions +ExecCGI\n";

1;
};
		# / template for config file
	}
	$document_root = $ENV{'DOCUMENT_ROOT'};
	$document_root =~ s/\/$//g;
	$installdir = $ENV{'SCRIPT_FILENAME'};
	$installdir =~ s/\/accessmanager.cgi$//g;
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Edit config file</i>
	</td></tr></table></td></tr></table>
	Document root directory: <i>$document_root</i><br>
	Install directory: <i>$installdir</i><br>
	<form action="accessmanager.cgi" method="post">
	<input type="hidden" name="todo" value="saveconfig">
	<i>$configerror</i>
	<textarea name="cfgfilecontent" cols="66" rows="15" wrap="off">$cfgfile</textarea><br><br>
	<table width="550" border="0" cellspacing="0" cellpadding="0"><tr><td><input type="submit" value="Save config file"></td><td  align="right"><input type="reset" value="Reset all changes"></td></tr></table>
	</form>};
}

sub CheckConfig
{
	eval('require "./accessmanager.pm"');
  return $@;
}

sub TopOfPage
{
	return qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\n\n<html>
	<head>
	<title>indexsoft access manager (ver. $VER)</title>
	<style type="text/css">
		body,p,input,td { font-size : 13px; color : Black; font-family : Arial, Helvetica, sans-serif; }
		p { margin-top : 0px; margin-bottom : 5px; }
		H4 { color : #5588BB; }
		body a { text-decoration : none; }
		body a:hover { text-decoration : underline; }
		body .small { font-size : 11px; text-align: right;}
	</style>
	</head>
	
	<body bgcolor="White">
	<center>
	<table width="600" border="0" cellspacing="0" cellpadding="0"><tr><td>
	<center>
	<h4>indexsoft access manager (shareware)</h4><hr size="1" noshade>
	<p><a href="accessmanager.cgi">protected directories</a> | <a href="accessmanager.cgi?todo=dirwalk">protect new directory</a> | <a href="accessmanager.cgi?todo=managehtpasswd">manage users</a> | <a href="accessmanager.cgi?todo=managehtgroups">manage groups</a> | <a href="http://www.indexsoft.com/passmanagerpro/">register now</a></p>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table bgcolor="#ffffff" width="100%" border="0" cellspacing="0" cellpadding="5"><tr><td>
	};
}

sub BottomOfPage
{
	return qq{</td></tr></table></td></tr></table><div class=small><a href="accessmanager.cgi?todo=configure">config file</a> | <a href="accessmanager.cgi?todo=checkver">check new version</a> | <a href="http://www.indexsoft.com">www.indexsoft.com</a></div>
	<!------- Start of HTML Code ------->
	<form action="http://www.hotscripts.com/cgi-bin/rate.cgi" method="POST" target="_new"><input type="hidden" name="ID" value="16420"><table BORDER="0" CELLSPACING="0" bgcolor="#800000"><tr><td><table border="0" cellspacing="0" width="100%" bgcolor="#EFEFEF" cellpadding="3"><tr><td align="center"><font face="arial, verdana" size="2"><b>Rate Our Script @
  <a href="http://www.hotscripts.com">HotScripts.com</a></b></font></td><td align="center"><select name="ex_rate" size="1"><option selected>Select</option><option value="5" selected>Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select></td><td align="center"><input type="submit" value="Go!"></td></tr></table></td></tr></table></form>
	<!------- End of HTML Code ------->
	<!-- --------- Start of ScriptSearch Rating Code --------- -->
	<form action="http://www.scriptsearch.com/cgi-bin/rateit.cgi" method="post" target="_new">
	<input type="hidden" name="ID" value="5542">
	<table border="0" cellspacing="0">
	<tr><td align="center">
	<font face="arial, verdana" size="2"><b>please rate it! @ 
	<i><a href="http://www.scriptsearch.com/details/5542.html">ScriptSearch.com</a>
	</i></b></font></td></tr>
	<tr><td align=center>
	<select name="rate" size="1" style="font-size:10px;">
	<option value="--">- Select -</option>
	<option value="5" selected>Excellent!</option>
	<option value="4">Very Good</option>
	<option value="3">Good</option>
	<option value="2">Fair</option>
	<option value="1">Poor</option>
	</select> 
	<input type="submit" value="Vote!" style="font-size:10px;">
	</td></tr></table>
	</form>
	<!-- --------- End of ScriptSearch Rating Code --------- -->
	<hr size="1" noshade>
	<p><font size="1">(note: rating forms removed from full version)</font></p></td></tr></table></body></html>};
}

sub HoldError
{
	print qq{<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Error occured!')\n//-->\n</SCRIPT><p><b style=\"color: #DC143C;\">Error:</b> @_[0]</p>\n};
}

sub ReadParameters
{
	use CGI;
	$MULTIPARTQUERY = new CGI;
	my @params = $MULTIPARTQUERY->param;
	my ($line);
	foreach $line(@params) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); }
}

